SystemOrganization addCategory: #AttractorModelisation!

DynamicComposableModel subclass: #UISecondVersion
	instanceVariableNames: 'mainView xtview ytview ztview plus slider lcolor varValues minus attr precisionStep secondaryViews odesInputX odesInputY odesInputZ rec odesValues sizeOfUI sliderSigma sliderRho sliderBeta sliderX sliderY sliderZ recView v'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!UISecondVersion commentStamp: 'antoineZim 3/24/2017 19:01' prior: 0!
I am the new version

Try in playground:
|ui|
ui := UISecondVersion new.
ui refresh.
ui openView!

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/23/2017 15:09'!
initialize
	self initialize: Attractor new! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:26'!
initialize: attrIn
	attr := attrIn.
	rec := Reconstructor new.
	v :=ViewMaker2Dfrom3D new .
	super initialize.
	self initializeWidgets.
	self extent: 1400 @ 750.
			! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:25'!
initializeWidgets

	self instantiateModels: #(
		mainView RoassalModel
		recView RoassalModel
		xtview RoassalModel
		ytview RoassalModel
		ztview RoassalModel
		plus ButtonModel 
		sliderSigma SliderModel
		sliderRho SliderModel
		sliderBeta SliderModel
		sliderX SliderModel
		sliderY SliderModel
		sliderZ SliderModel
		lcolor CheckBoxModel
		varValues LabelModel
		minus ButtonModel
		precisionStep TextInputFieldModel
		odesValue LabelModel
		odesInputX TextInputFieldModel
		odesInputY TextInputFieldModel
		odesInputZ TextInputFieldModel
		sizeOfUI LabelModel
		).
	layout := (SpecLayout composed
	newRow:[ :firstCol|
		firstCol 
		newColumn: [ :bCol | bCol 
				newRow: [ :r| r 
					newColumn:[:r1 | r1 
						add: #odesInputX ; 
						add: #odesInputY; 
						add: #odesInputZ]] height: 150;
				newRow: [:r1 | r1  
					add: #odesValues ]height: 25 ] width:250;
		newColumn: [ :col |
			col
				newRow: [:r | r add: #mainView; newColumn: [:c | c add: #sliderSigma; add: #sliderRho; add: #sliderBeta;
																					add: #sliderX ;add:#sliderY ; add:#sliderZ]];
			
				newRow:[:c | c 	add: #xtview; addSplitter;
									add: #ytview; addSplitter;
									add: #ztview];
				addSplitter;
				newRow: [:c| c add: #recView ];
				newRow: [:c | c add: #sizeOfUI; add: #varValues;add: #lcolor] height:25 ;
				newColumn: [:aCol| aCol
					newRow: [ :aRow | aRow  
					add: #minus ;
					add: #plus;
					add: #precisionStep ] height: 25 ]]
			
		];
	yourself).

	"Odes"
	odesInputX := TextInputFieldModel new.
	odesInputX beForCode.
	self odesInputX entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:x :y :z :sigma :rho :beta | your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0) ')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)  ') isNumber ifTrue: [ rec odesX:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,']')]. self refresh ]].
		
	odesInputY := TextInputFieldModel new.
	odesInputY beForCode.
	odesInputY entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:x :y :z :sigma :rho :beta | your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0) ')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)  ') isNumber ifTrue: [ rec odesY:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,']')]. self refresh ]].
	
	odesInputZ := TextInputFieldModel new.
	odesInputZ beForCode.
	odesInputZ entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:x :y :z :sigma :rho :beta | your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0) ')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)  ') isNumber ifTrue: [ rec odesZ:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,']')]. self refresh ]].
	
	odesValues := LabelModel new.
	self odesValues label:'odes= ',((rec odes) asString) .
	"Views"
	"to REMOVE:"

	v values: rec rk4.
	
	":END to REMOVE"
	recView := RoassalModel new.
	mainView := RoassalModel new.
	xtview := RoassalModel new.
	ytview := RoassalModel new.
	ztview := RoassalModel new.
	
	self recView script: [ :view :canvas |
		view addFromView: (v view).
		canvas camera focusOnCenter.
	].
	self mainView script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt: 4).
		canvas camera focusOnCenter.
	].
	self xtview script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt:1) .
		canvas camera focusOnCenter.
	].
	self ytview script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt:2).
		canvas camera focusOnCenter.
	].
	self ztview script: [ :view :canvas |
		view addFromView: (attr viewForGraphAt:3).
		canvas camera focusOnCenter.
	].

	"Sliders"
	sliderSigma :=  SliderModel new.
	sliderRho :=  SliderModel new.
	sliderBeta :=  SliderModel new.
	sliderX :=  SliderModel new.
	sliderY :=  SliderModel new.
	sliderZ :=  SliderModel new.
	sliderSigma "value: attr sigma;"min:0;max:20;label:'0<=sigma<=20'.
	sliderRho "value: attr rho ;"min:0;max:10;label:'0<=rho<=10';quantum: 0.2.
	sliderBeta "value: attr beta ;"min:0;max:40.0;label:'0<=beta<=40'.
	sliderX "value: (attr initialState at:1);" min:0;max:20;label:'0<=x<=10'.
	sliderY "value: (attr initialState at:2);" min:0;max:20;label:'0<=y<=10'.
	sliderZ "value: (attr initialState at:3);" min:0;max:20;label:'0<=z<=10'.
	self sliderSigma whenValueChangedDo: [:value |attr sigma: value. self refresh].
	self sliderRho whenValueChangedDo: [:value |attr rho: value. self refresh].
	self sliderBeta whenValueChangedDo: [:value |attr beta: value. self refresh].

	self sliderX whenValueChangedDo: [:value | attr stateX: value. self refresh].
	self sliderY whenValueChangedDo: [:value | attr stateY: value. self refresh].
	self sliderZ whenValueChangedDo: [:value | attr stateZ: value. self refresh].
					
	"feedback values"
	varValues := LabelModel new.
	self varValues label:'sigma=',(attr sigma asString) ",'   r=',(attr r asString),'   precision=',(attr precision asString),'\n'",'   p =',(attr rho asString ),'   beta =',(attr beta asString ) .
	
	"Modifiers"
	precisionStep := TextInputFieldModel new.
	self precisionStep entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Precision (Integer)';
		whenTextChanged: [:text| (text asInteger) isNil not ifTrue: [attr precision: (text asInteger)]. self refresh ].
	self minus label: 'zoom--'; state: false; 
			action: [attr view canvas camera scale: attr view canvas camera scale - 20.
	    attr view signalUpdate. self refresh].
	self plus label: 'r++'; state: false; 
			action: [attr r: attr r +1.  self refresh ].

	lcolor := CheckBoxModel new.
	self lcolor whenChangedDo: [:bool| bool 
		ifTrue: [attr ds connectColor: Color green . self refresh ] 
		ifFalse:  [attr ds disconnect. attr ds connectColor: Color transparent. self refresh ]] .

	
	
	"Testers"
	sizeOfUI := LabelModel new.
	self sizeOfUI label:'UIsize= ',((self sizeInMemory ) asString) .! !

!UISecondVersion methodsFor: 'accessing' stamp: 'antoineZim 2/23/2017 16:34'!
layout
	^layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:38'!
lcolor
	^lcolor! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/28/2017 11:44'!
mainView
	^mainView! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:13'!
odesInputX
	^odesInputX! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:13'!
odesInputY
	^odesInputY! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:13'!
odesInputZ
	^odesInputZ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 14:42'!
odesValues
	^odesValues! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 2/23/2017 16:40'!
openView
	
	self openWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 20:43'!
precisionStep
	^precisionStep! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/24/2017 18:54'!
recView
	^recView ! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 3/25/2017 17:25'!
refresh
"TODO: find another solution to remake the model attr"
"attr refresh -> not working"
"attr view refresh -> not working"
	attr rebuild .
	rec rebuild.
	v values: rec rk4.
	self varValues label:'sigma=',(attr sigma asString) ,'   rho =',(attr rho asString ),'   beta =',(attr beta asString ) ",'   r=',(attr r asString),'   precision=',(attr precision asString),'\n'".
	self odesValues label: 'odes= ',((rec odes) asString).
	self sizeOfUI label: 'sizeUI',((self sizeInMemory ) asString).
	self needRebuild: false.
	self buildWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:10'!
sizeOfUI
	^sizeOfUI ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderBeta
	^sliderBeta ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderRho
	^sliderRho! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderSigma
	^sliderSigma! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderX
	^sliderX! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderY
	^sliderY! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:24'!
sliderZ
	^sliderZ! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 2/27/2017 16:37'!
varValues
	^varValues! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:39'!
xtview
	^xtview! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:39'!
ytview
	^ytview! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:38'!
ztview
	^ztview! !

Object subclass: #Attractor
	instanceVariableNames: 'sigma rho beta dt values b attrView xValues yValues zValues graphList viewList ds precision xSteppedValues ySteppedValues zSteppedValues state initialState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Attractor commentStamp: 'antoineZim 3/25/2017 16:28' prior: 0!
I am an empirical model of the Lorenz Attractor.

|a|
a := Attractor new.
a rebuild.
a!

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
beta
	^beta! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
beta: val
	beta := val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:37'!
buildAllViews 
	^(self buildAllViews: graphList)! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:37'!
buildAllViews: graphCollection
	|newViewList|
	newViewList := OrderedCollection new.
	graphCollection do: [ :eachB | newViewList add: (self buildView: eachB) ].
	^newViewList! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher

	b := RTGrapher new.
	ds := RTData new.
	ds dotShape ellipse size: 1; color: (Color blue).
	ds points: values.
	ds x: [:val | val at: 1]; y: [:val| val at: 2].
	b add: ds.
	b build.
	^b! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher: valueList
	|ab ads|
	ab := RTGrapher new.
	graphList add: ab.
	ads := RTData new.
	ads dotShape ellipse size: 1.
	ads points: valueList .
	ads connectColor: Color red.
	"ads y: #yourself."
	ab add: ads.
	ab build.
	! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher: anOrderedCollection withColor: color
	|ab ads|
	ab := RTGrapher new.
	ads := RTData new.
	ads dotShape ellipse size: 1; color: (Color blue).
	ads points: anOrderedCollection.
	ads connectColor: Color color.
	ads y: #yourself.
	ab add: ads.
	ab shouldUseNiceLabels: true.
	
	ab build.
	graphList add: ab! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/25/2017 16:33'!
buildValues
	| system stepper solver tempState |

	
	graphList :=OrderedCollection new.
	viewList :=OrderedCollection new.

	
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	state := initialState .
	system := ExplicitSystem
		block:[:val :t | |dx dy dz x y z|
			x := val at: 1. y := val at: 2. z := val at: 3.
			
			dx := sigma * (y - x).
			dy := beta * x - y - (x * z).
			dz := (-1 * rho * z + (x * y)).
			{dx. dy. dz}.
			].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	tempState := state .
	values := (0.0 to: 100.0 by: dt) collect:[:t |
		tempState:= stepper doStep: tempState time:t stepSize: dt].
	values do: [ :val | 
						xValues add: (val at:1). 
						yValues add: (val at:2).
						zValues add: (val at:3)].
	xSteppedValues:= OrderedCollection new.
	ySteppedValues:= OrderedCollection new.
	zSteppedValues:= OrderedCollection new.
	xSteppedValues := xValues .
	ySteppedValues := yValues .
	zSteppedValues := zValues .
	"xSteppedValues addAllLast: xValues from: 1 to: xValues size  by: precision .
	ySteppedValues addAllLast: yValues from: 2 to: yValues size  by: precision .
	zSteppedValues addAllLast: zValues from: 3 to: zValues size  by: precision ."! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:27'!
buildView: ab
	|aView anElementsAndEdges |
	aView := RTView new.
	aView @ RTDraggableView.

	anElementsAndEdges := ab view elements, ab view edges.
	aView addAll: anElementsAndEdges.

	
	aView canvas camera noInitializationWhenOpen.
	aView canvas camera scale: 1.5.

	^aView! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:20'!
ds
	^ds! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
dt
	^dt! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
dt: val
	dt:= val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
elements
	^(b view elements)! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
graphList
	^graphList ! !

!Attractor methodsFor: 'initialization' stamp: 'antoineZim 3/24/2017 15:31'!
initialState
	^initialState ! !

!Attractor methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 16:29'!
initialize
	
	sigma := 10.0.
	beta := 30.0.
	rho := 8.0/3.0.
	dt := 0.1.
	precision := 25.
	initialState := #(10.0 10.0 10.0).
	self rebuild! !

!Attractor methodsFor: 'hooks' stamp: 'antoineZim 2/28/2017 23:21'!
openRTGrapher
	b open! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
precision
	^precision! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
precision: val
	precision := val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/25/2017 16:29'!
rebuild
	self buildValues .
	"self halt."
	self buildRTGrapher: xSteppedValues .
	self buildRTGrapher: ySteppedValues .
	self buildRTGrapher: zSteppedValues .
	graphList add: (self buildRTGrapher).
	viewList := self buildAllViews! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
rho
	^rho! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
rho: val
	rho := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
sigma
	^sigma! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
sigma: val
	sigma := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/24/2017 14:21'!
state
	^state! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/24/2017 14:28'!
stateX: val
	state at:1 put: val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/24/2017 14:28'!
stateY: val
	state at:2 put: val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/24/2017 14:28'!
stateZ: val
	state at:3 put: val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/24/2017 19:31'!
values
	^values! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
values: val
	values := val
! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
viewForGraphAt: indexInGraphList
	^((graphList at: indexInGraphList ) view)! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
viewList
	^viewList 
	! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/24/2017 17:48'!
xValues
	^xValues! !

Object subclass: #Reconstructor
	instanceVariableNames: 'odes state data_length parameters initState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Reconstructor commentStamp: 'antoineZim 3/24/2017 16:32' prior: 0!
Make the reconstruction 
parameters := #(sigma,rho beta)
state := #(x y z)
odes := [:xyz  :sigmaRhoBeta | odesFunctions  ]

Try in playground: 
| r |
r := Reconstructor new .
r generate.
r makeCompareGraphs !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 17:26'!
initialize
	odes := self lorenz_odes.
	initState := (Array with: -8.5 with: 8.0 with: 27.0 ).
	parameters :=(Array with: 10.0 with: 8/3.0 with: 28.0).
	data_length := 1000.
	! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:54'!
lorenz_generate
	odes := self lorenz_odes .
	^(self rebuild)! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 18:25'!
lorenz_odes
	^(Array 	with: [:x :y :z :sigma :rho :beta | sigma * (y - x)  ] 
				with:[:x :y :z :sigma :rho :beta | beta * x - y - (x * z)] 
				with: [:x :y :z :sigma :rho :beta | (-1 * rho * z + (x * y))]).

! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 16:34'!
makeCompareGraphs
	| g g1 g2 g3 ds1 ds2 ds3 rec x y z |
rec := (Reconstructor new) lorenz_generate.

x := (rec collect: [ : each| each at: 1 ]).
y := (rec collect: [ : each| each at: 2 ]).
z := (rec collect: [ : each| each at: 3 ]).

g := RTMultiGrapher new.

g1 := RTGrapher new.
ds1 := RTData new.
ds1 label: 'x values'.
ds1 connectColor: Color red.
ds1 points: x.
ds1 interaction highlightDataset: Color black.
g1 add: ds1.
g2 := RTGrapher new.
ds2 := RTData new.
ds2 label: 'y values'.
ds2 connectColor: Color blue.
ds2 points: y.
ds2 interaction highlightDataset: Color purple.
g2 add: ds2.

g3 := RTGrapher new.
ds3 := RTData new.
ds3 label: 'z values'.
ds3 connectColor: Color green.
ds3 points: z.
ds3 interaction highlightDataset: Color black.
g3 add: ds3.

g1 axisY
	title: 'y 1';
	color: Color red.
g2 axisY
	title: 'y 2';
	color: Color blue.
g3 	axisY
	title: 'y 3';
	color: Color green.
g add: g1.
g add: g2.
g add: g3.
g legend.
^ g! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:18'!
odes
	^odes ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:06'!
odesX: val
	odes at:1 put: val! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:06'!
odesY: val
	odes at:2 put: val! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:06'!
odesZ: val
	odes at:3 put: val! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 16:05'!
parameters
	^parameters ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 16:05'!
parameters: val
	parameters :=val! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:53'!
rebuild
	|data tempState|
	tempState := state.
	data := self rk4.
	^data  
	
! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:17'!
rk4
	| system stepper solver s p r dt values tempState |
	s := parameters at:1 .
	p := parameters at:2.
	r := parameters at:3.
	dt := 0.1.
	state := initState.
	system := ExplicitSystem
		block:[:xyz :t | |dx dy dz x y z|
			x := xyz at: 1. y := xyz at: 2. z := xyz at: 3.
			dx := (odes at:1) valueWithArguments: (Array with:x with:y with:z with:s with:p with:r) .
			dy := (odes at:2) valueWithArguments: (Array with:x with:y with:z with:s with:p with:r).
			dz := (odes at:3) valueWithArguments: (Array with:x with:y with:z with:s with:p with:r).
			{dx. dy. dz}.
			].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	tempState := state .
	values := (0.0 to: 100.0 by: dt) collect:[:t |
		tempState:= stepper doStep: tempState time:t stepSize: dt].
	^values! !

Object subclass: #ViewMaker2Dfrom3D
	instanceVariableNames: 'values view graph dataset seriesGraphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!ViewMaker2Dfrom3D commentStamp: 'antoineZim 3/24/2017 19:06' prior: 0!
Try in playground:
|v|
v :=ViewMaker2Dfrom3D new .
v values: Reconstructor new rk4.
v view!

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 19:33'!
buildGraph
	graph := RTGrapher new.
	dataset := RTData new.
	dataset dotShape ellipse size: 1; color: (Color blue).
	dataset points: values.
	dataset x: [:val | val at: 1]; y: [:val| val at: 2].
	graph add: dataset.
	graph build.
	^graph! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:50'!
buildSeriesGraphs
	| xValues yValues zValues dsX dsY dsZ |
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	values do: [ :val | 
						xValues add: (val at:1). 
						yValues add: (val at:2).
						zValues add: (val at:3)].
	seriesGraphs := OrderedCollection new.
	seriesGraphs add: RTGrapher new.
	seriesGraphs add: RTGrapher new.
	seriesGraphs add: RTGrapher new.
	
	dsX := RTData new.
	dsX dotShape ellipse size: 1; color: (Color blue).
	dsX points: xValues.
	dsX connectColor: Color red.
	
	dsY := RTData new.
	dsY dotShape ellipse size: 1; color: (Color blue).
	dsY points: yValues.
	dsY connectColor: Color red.

	dsZ := RTData new.
	dsZ dotShape ellipse size: 1; color: (Color blue).
	dsZ points: zValues.
	dsZ connectColor: Color red.
	

	(seriesGraphs at:1) add: dsX.
	(seriesGraphs at:2) add: dsY.
	(seriesGraphs at:3) add: dsZ.
	
	
	
	seriesGraphs  do: [:g| g build].
	^seriesGraphs ! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 18:38'!
graph
	^graph! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:41'!
rebuild
	self buildGraph.
	self buildSeriesGraphs ! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 19:29'!
values: val
	values:= val.
	self rebuild ! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 19:28'!
view
	^(graph view)! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:42'!
viewX
	^(seriesGraphs at:1 view)! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:42'!
viewY
	^(seriesGraphs at:2 view)! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:42'!
viewZ
	^(seriesGraphs at:3 view)! !
